/* FILE: test.c         Copyright (c), Symmetric Research, 1986 1998
 *
 * Test an FFT function with a console text display of the results.
 *
 *
 *
 *
 */

#include <stdio.h>
#include <math.h>

#include "fft.h"




/* COMPLEX ARRAY TO TRANSFORM: */

#define NFFT    128

COMPLEX A[NFFT];






/* MAIN:
 *
 *
 *
 */

void main( void) {

        int i; void Display( char *msg);



        /* Setup a function to transform. */

        for ( i = 0 ; i < NFFT ; i++ ) {

                /* Multiple cexp wave cycles for example ... */

                A[i].r =   cos( 2*PI*i*4/NFFT);
                A[i].i = - sin( 2*PI*i*4/NFFT);

                }



        /* Display some of the starting values. */

        Display( "FFT starting values:");



        /* Compute and display the forward transform. */

        FFT( A, NFFT, FORWARD);

        Display( "Forward transform:");



        /* Compute and display the inverse transform. */

        FFT( A, NFFT, INVERSE);

        Display("Inverse transform, NOT NORMALIZED:");


}





/* DISPLAY HELPER FUNCTION:
 *
 *
 *
 */

void Display( char *msg) {

        int i;


        /* Display the message. */

        printf( "%s ( any kbhit will continue ... )\n\n", msg);


        /* Print a few values. */

#define FMT     "   ( A[%1d].r, A[%1d].i) = ( %+9.4f, %+9.4f )\n"

        for ( i = 0 ; i < 8 ; i++ )

                printf( FMT, i, i, A[i].r, A[i].i );

        printf( "   .\n");
        printf( "   ... (etc)\n");

        printf( "\n");



        /* Wait for a keypress to continue. */

        while ( !kbhit() )

                /* wait */ ; getch();

}
